Card Game Cheater HDU - 1962 +二分图最大匹配

问题:

Adam and Eve play a card game using a regular deck of 52 cards. The rules are simple. The players sit on opposite sides of a table, facing each other. Each player gets k cards from the deck and, after looking at them, places the cards face down in a row on the table. Adam’s cards are numbered from 1 to k from his left, and Eve’s cards are numbered 1 to k from her right (so Eve’s i:th card is opposite Adam’s i:th card). The cards are turned face up, and points are awarded as follows (for each i ∈ {1, . . . , k}): 
• If Adam’s i:th card beats Eve’s i:th card, then Adam gets one point. 
• If Eve’s i:th card beats Adam’s i:th card, then Eve gets one point. 
• A card with higher value always beats a card with a lower value: a three beats a two, a four beats a three and a two, etc. An ace beats every card except (possibly) another ace. 
• If the two i:th cards have the same value, then the suit determines who wins: hearts beats all other suits, spades beats all suits except hearts, diamond beats only clubs, and clubs does not beat any suit. 

For example, the ten of spades beats the ten of diamonds but not the Jack of clubs. This ought to be a game of chance, but lately Eve is winning most of the time, and the reason is that she has started to use marked cards. In other words, she knows which cards Adam has on the table before he turns them face up. Using this information she orders her own cards so that she gets as many points as possible. 

Your task is to, given Adam’s and Eve’s cards, determine how many points Eve will get if she plays optimally. 

Input

There will be several test cases. The first line of input will contain a single positive integer N giving the number of test cases. After that line follow the test cases. 

Each test case starts with a line with a single positive integer k ≤ 26 which is the number of cards each player gets. The next line describes the k cards Adam has placed on the table, left to right. The next line describes the k cards Eve has (but she has not yet placed them on the table). A card is described by two characters, the first one being its value (2, 3, 4, 5, 6, 7, 8 ,9, T, J, Q, K, or A), and the second one being its suit (C, D, S, or H). Cards are separated by white spaces. So if Adam’s cards are the ten of clubs, the two of hearts, and the Jack of diamonds, that could be described by the line 

TC 2H JD 

Output

For each test case output a single line with the number of points Eve gets if she picks the optimal way to arrange her cards on the table.

Sample Input

3
1
JD
JH
2
5D TC
4C 5H
3
2H 3H 4H
2D 3D 4D

Sample Output

1
1
2

题意:Adam和Eve打牌,Eve可以看到Adam的牌,牌的顺序先看大小,如果大小一样,再看C,D,S,H(依次增大),每次出一张牌,大的赢一次,求出Eve能赢得最多次。

思路:可将两个人的牌构建一个二分图,根据贪心的思想,如果左边 i 牌 > 右边 j 牌,则连一条 边,由于要获得最大得分,每条匹配边就是一分,因此本题就是找图的最大匹配。

代码:

#include
#include
#include
using namespace std;
int a[200],e[120][120],book[120];
int n,b[200],tag[50];
char s[3][50][3];
void init()
{
    a['2']=2;
    a['3']=3;
    a['4']=4;
    a['5']=5;
    a['6']=6;
    a['7']=7;
    a['8']=8;
    a['9']=9;
    a['T']=10;
    a['J']=11;
    a['Q']=12;
    a['K']=13;
    a['A']=14;
    b['C']=1;
    b['D']=2;
    b['S']=3;
    b['H']=4;
}

int dfs(int x)
{
    for(int i=1; i<=n; i++)
    {
        if(book[i]==0&&e[x][i]==1)
        {
            book[i]=1;
            if(tag[i]==0||dfs(tag[i]))
            {
                tag[i]=x;
                return 1;
            }
        }
    }
    return 0;
}
int main()
{
    init();
    int t;
    scanf("%d",&t);
    while(t--)
    {
        memset(tag,0,sizeof(tag));
        memset(e,0,sizeof(e));
        scanf("%d",&n);
        for(int i=1; i<=n; i++)
            scanf("%s",s[2][i]);
        for(int i=1; i<=n; i++)
            scanf("%s",s[1][i]);
        for(int i=1; i<=n; i++)
            for(int j=1; j<=n; j++)
            {
                int x=a[s[1][i][0]];
                int y=a[s[2][j][0]];
                if(x>y)
                    e[i][j]=1;
                else if(x==y)
                {
                    int dx=b[s[1][i][1]];
                    int dy=b[s[2][j][1]];
                    if(dx>dy)
                        e[i][j]=1;
                }
            }
        int sum=0;
        for(int i=1; i<=n; i++)
        {
            memset(book,0,sizeof(book));
            if(dfs(i))
                sum=sum+1;
        }
        printf("%d\n",sum);
    }
    return 0;
}


 

你可能感兴趣的:(二分图最大匹配)